#include "V3Vector.h"
#include "StlVector.h"

namespace AMDiS {

  M33::M33()
  {
    data.resize(9);
    for (int i = 0; i < 9; i++) {
      data[i] = 0.0;
    }
  };

  M33::~M33()
  {};

  void M33::set(int row, int col, double value)
  {
    data[row * 3 + col] = value;
  };

  void M33::print()
  {
    ::std::cout << "[";

    for (int i = 0; i < 9; i++) {
      ::std::cout << data[i] << ",";
    }

    ::std::cout << "]" << ::std::endl;
  };

/*  double norm(::std::vector<V3> *v) {
    double result = 0.0;

    ::std::vector<V3>::iterator it;

    for (it = v->begin(); it < v->end(); ++it) {
      result += (*it)[0] * (*it)[0] + (*it)[1] * (*it)[1] + (*it)[2] * (*it)[2];
    }

    return(sqrt(result));
  };

  void setValue(::std::vector<V3>& v, double value)
  {
    ::std::vector<V3>::iterator it;

    for (it = v.begin(); it < v.end(); ++it) {
      (*it)[0] = value;
      (*it)[1] = value;
      (*it)[2] = value;
    };
  };

  const V3& operator += (V3& x1, const V3 x2)
  {
    x1[0] += x2[0];
    x1[1] += x2[1];
    x1[2] += x2[2];

    return(x1);
  }

  const ::std::vector<V3>& operator*=(::std::vector<V3>& x, double scal)
  {
    ::std::vector<V3>::iterator it;

    for (it = x.begin(); it < x.end(); ++it) {
      (*it)[0] *= scal;
      (*it)[1] *= scal;
      (*it)[2] *= scal;
    }

    return(x);
  };

  const ::std::vector<V3>& operator+=(::std::vector<V3>& x1,
					  const ::std::vector<V3>& x2)
  {
    ::std::vector<V3>::iterator it1;
    ::std::vector<V3>::const_iterator it2;

    for (it1 = x1.begin(), it2 = x2.begin(); 
	 it1 < x1.end(); 
	 ++it1, ++it2) {
      (*it1)[0] += (*it2)[0];
      (*it1)[1] += (*it2)[1];
      (*it1)[2] += (*it2)[2];
    };

    return(x1);
  };

  double operator*(::std::vector<V3>& x1, ::std::vector<V3>& x2)
  {
    double result = 0.0;

    ::std::vector<V3>::iterator it1, it2;

    for (it1 = x1.begin(), it2 = x2.begin(); 
	 it1 < x1.end(); 
	 ++it1, ++it2) {
      result += (*it1)[0] * (*it2)[0] + 
	        (*it1)[1] * (*it2)[1] + 
	        (*it1)[2] * (*it2)[2];   
    }

    return(result);
  };


  void axpy(double alpha, const ::std::vector<V3>& x, ::std::vector<V3>& y)
  {
    ::std::vector<V3>::const_iterator it1;
    ::std::vector<V3>::iterator it2;

    for (it1 = x.begin(), it2 = y.begin(); 
	 it1 < x.end(); 
	 ++it1, ++it2) {
      (*it2)[0] += alpha * (*it1)[0];
      (*it2)[1] += alpha * (*it1)[1];
      (*it2)[2] += alpha * (*it1)[2];
    }
  };

  void xpay(double alpha, const ::std::vector<V3>& x, ::std::vector<V3>& y)
  {
    ::std::vector<V3>::const_iterator it1;
    ::std::vector<V3>::iterator it2;

    for (it1 = x.begin(), it2 = y.begin(); 
	 it1 < x.end(); 
	 ++it1, ++it2) {
      (*it2)[0] = alpha * (*it2)[0] + (*it1)[0];
      (*it2)[1] = alpha * (*it2)[1] + (*it1)[1];
      (*it2)[2] = alpha * (*it2)[2] + (*it1)[2];
    }
  };

  V3 mult(M33 mat, V3 vec) 
  {
    V3 result(3);

    result[0] = mat[0] * vec[0] + mat[1] * vec[1] + mat[2] * vec[2];
    result[1] = mat[3] * vec[0] + mat[4] * vec[1] + mat[5] * vec[2];
    result[2] = mat[6] * vec[0] + mat[7] * vec[1] + mat[8] * vec[2];

//     ::std::cout << "------------------------" << ::std::endl;
//     ::std::cout << "M = ";
//     mat.print();
//     ::std::cout << "v = ";
//     print(&vec);
//     ::std::cout << "r = ";
//     print(&result);

    return(result);
  };

  void print(::std::vector<V3> *v)
  {
    ::std::vector<V3>::const_iterator it;

    ::std::cout << "[";

    for (it = v->begin(); it < v->end(); ++it) {
      ::std::cout << "(" << (*it)[0] << "," << (*it)[1] << "," << (*it)[2] << ") ";
    }

    ::std::cout << "]" << ::std::endl;
  };
*/
}
